using System;
using System.Drawing;
using System.Windows;
using System.Windows.Forms;

class MyForm: Form
{
    Rectangle frameRect;
    public static void Main()
    {
        Form frm = new MyForm();
        frm.Size=new Size(300, 160);
        frm.Text = "Reversible frame test";
        Application.Run(frm);
    }

    protected override void OnMouseDown(MouseEventArgs e)
    {
        if(e.Button==MouseButtons.Left)
        {
            //   
            frameRect.Location=new Point(e.X, e.Y); 
            frameRect.Size=new Size(0, 0);
        }
        base.OnMouseDown(e); //  
    }

    protected override void OnMouseUp(MouseEventArgs e)
    {
        if(e.Button==MouseButtons.Left)
        {
            DrawFrame(); //  
            frameRect.Size=new Size(0, 0);
        }
        base.OnMouseUp(e); //  
    }

    protected override void OnMouseMove(MouseEventArgs e)
    {
        if(e.Button==MouseButtons.Left)
        {
            DrawFrame(); //  
            frameRect.Width = e.X - frameRect.Left;
            frameRect.Height = e.Y - frameRect.Top;
            DrawFrame(); //  
        }
        base.OnMouseMove(e); //  
    }

    protected void DrawFrame()
    {
        if (!frameRect.Size.IsEmpty)
        {
            Rectangle r=RectangleToScreen(frameRect);
            ControlPaint.FillReversibleRectangle(r,
                          Color.FromArgb(40, 0, 0, 160));
        }
    }

    protected override void OnLoad(EventArgs e)
    {
        SetStyle(ControlStyles.UserPaint, true);
        SetStyle(ControlStyles.AllPaintingInWmPaint, true);
        SetStyle(ControlStyles.DoubleBuffer, true);
        Label lbl=new Label();
        Font fnt=new Font("Arial", 24);
        lbl.Font=fnt;
        lbl.Text="Label";
        lbl.Location=new Point(50,30);
        lbl.AutoSize=true;
        Controls.Add(lbl);
        base.OnLoad(e);
    }
}
